diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-phy-cca-test.cc ns-3.45/src/wifi/test/wifi-phy-cca-test.cc
--- ns-3.44/src/wifi/test/wifi-phy-cca-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-phy-cca-test.cc	2025-06-01 20:34:45.640702200 -0700
@@ -7,7 +7,9 @@
  */
 
 #include "ns3/constant-obss-pd-algorithm.h"
-#include "ns3/he-phy.h"
+#include "ns3/eht-configuration.h"
+#include "ns3/eht-phy.h"
+#include "ns3/eht-ppdu.h"
 #include "ns3/he-ppdu.h"
 #include "ns3/ht-ppdu.h"
 #include "ns3/interference-helper.h"
@@ -30,8 +32,10 @@
 #include "ns3/wifi-phy-listener.h"
 #include "ns3/wifi-psdu.h"
 #include "ns3/wifi-spectrum-value-helper.h"
+#include "ns3/wifi-standards.h"
 #include "ns3/wifi-utils.h"
 
+#include <algorithm>
 #include <memory>
 #include <vector>
 
@@ -39,21 +43,32 @@
 
 NS_LOG_COMPONENT_DEFINE("WifiPhyCcaTest");
 
-constexpr MHz_u P20_CENTER_FREQUENCY{5180};
+constexpr MHz_u P20_CENTER_FREQUENCY{5955};
 constexpr MHz_u S20_CENTER_FREQUENCY = P20_CENTER_FREQUENCY + MHz_u{20};
 constexpr MHz_u P40_CENTER_FREQUENCY = P20_CENTER_FREQUENCY + MHz_u{10};
 constexpr MHz_u S40_CENTER_FREQUENCY = P40_CENTER_FREQUENCY + MHz_u{40};
 constexpr MHz_u P80_CENTER_FREQUENCY = P40_CENTER_FREQUENCY + MHz_u{20};
 constexpr MHz_u S80_CENTER_FREQUENCY = P80_CENTER_FREQUENCY + MHz_u{80};
 constexpr MHz_u P160_CENTER_FREQUENCY = P80_CENTER_FREQUENCY + MHz_u{40};
+constexpr MHz_u S160_CENTER_FREQUENCY = P160_CENTER_FREQUENCY + MHz_u{160};
+constexpr MHz_u P320_CENTER_FREQUENCY = P160_CENTER_FREQUENCY + MHz_u{80};
 const Time smallDelta = NanoSeconds(1);
-// add small delta to be right after aCCATime, since test checks are scheduled before wifi events
-const Time aCcaTime = MicroSeconds(4) + smallDelta;
-const std::map<MHz_u, Time> PpduDurations = {
+const Time aCcaTime = MicroSeconds(4);
+const Time phyHeaderDuration = MicroSeconds(32);
+// add small delta to be right after aCcaTime, since test checks are scheduled before wifi
+// events
+const Time aCcaTimeWithDelta = aCcaTime + smallDelta;
+const std::map<MHz_u, Time> hePpduDurations = {
     {20, NanoSeconds(1009600)},
     {40, NanoSeconds(533600)},
     {80, NanoSeconds(275200)},
 };
+const std::map<MHz_u, Time> ehtPpduDurations = {
+    {20, NanoSeconds(1017600)},
+    {40, NanoSeconds(541600)},
+    {80, NanoSeconds(287200)},
+    {160, NanoSeconds(178400)},
+};
 
 /**
  * @ingroup wifi-test
@@ -108,6 +123,13 @@
      * @return a HE PPDU
      */
     Ptr<HePpdu> CreateDummyHePpdu(MHz_u bandwidth, const WifiPhyOperatingChannel& channel);
+    /**
+     * Create a EHT PPDU
+     * @param bandwidth the bandwidth used for the transmission the PPDU
+     * @param channel the operating channel of the PHY used for the transmission
+     * @return a EHT PPDU
+     */
+    Ptr<EhtPpdu> CreateDummyEhtPpdu(MHz_u bandwidth, const WifiPhyOperatingChannel& channel);
 
     /**
      * Function to verify the CCA threshold that is being reported by a given PHY entity upon
@@ -127,16 +149,19 @@
     Ptr<SpectrumWifiPhy> m_phy;               ///< The spectrum PHY
     Ptr<ObssPdAlgorithm> m_obssPdAlgorithm;   ///< The OBSS-PD algorithm
     Ptr<VhtConfiguration> m_vhtConfiguration; ///< The VHT configuration
+    Ptr<EhtConfiguration> m_ehtConfiguration; ///< The EHT configuration
 
     dBm_u m_CcaEdThreshold; ///< The current CCA-ED threshold for a 20 MHz subchannel
-    dBm_u m_CcaSensitivity; ///< The current CCA sensitivity threshold for signals that occupy the
-                            ///< primary 20 MHz channel
+    dBm_u m_CcaSensitivity; ///< The current CCA sensitivity threshold for signals that occupy
+                            ///< the primary 20 MHz channel
 
     VhtConfiguration::SecondaryCcaSensitivityThresholds
-        m_secondaryCcaSensitivityThresholds; ///< The current CCA sensitivity thresholds for signals
-                                             ///< that do not occupy the primary 20 MHz channel
+        m_secondaryCcaSensitivityThresholds; ///< The current CCA sensitivity thresholds for
+                                             ///< signals that do not occupy the primary 20 MHz
+                                             ///< channel
 
-    dBm_u m_obssPdLevel; ///< The current OBSS-PD level
+    dBm_u m_obssPdLevel;         ///< The current OBSS-PD level
+    dBm_u m_per20CcaSensitivity; ///< The current CCA sensitivity threshold for Per 20MHz check
 };
 
 WifiPhyCcaThresholdsTest::WifiPhyCcaThresholdsTest()
@@ -144,7 +169,8 @@
       m_CcaEdThreshold{-62.0},
       m_CcaSensitivity{-82.0},
       m_secondaryCcaSensitivityThresholds{dBm_u{-72}, dBm_u{-72}, dBm_u{-69}},
-      m_obssPdLevel{-82.0}
+      m_obssPdLevel{-82.0},
+      m_per20CcaSensitivity{-72.0}
 {
 }
 
@@ -223,6 +249,29 @@
     return Create<HePpdu>(psdu, txVector, channel, MicroSeconds(100), 0);
 }
 
+Ptr<EhtPpdu>
+WifiPhyCcaThresholdsTest::CreateDummyEhtPpdu(MHz_u bandwidth,
+                                             const WifiPhyOperatingChannel& channel)
+{
+    WifiTxVector txVector{EhtPhy::GetEhtMcs0(),
+                          0,
+                          WIFI_PREAMBLE_EHT_MU,
+                          NanoSeconds(800),
+                          1,
+                          1,
+                          0,
+                          bandwidth,
+                          false};
+    WifiConstPsduMap psdus;
+    psdus.emplace(1, CreateDummyPsdu());
+    return Create<EhtPpdu>(psdus,
+                           txVector,
+                           channel,
+                           MicroSeconds(100),
+                           0,
+                           HePpdu::PSD_NON_HE_PORTION);
+}
+
 void
 WifiPhyCcaThresholdsTest::VerifyCcaThreshold(const Ptr<PhyEntity> phy,
                                              const Ptr<const WifiPpdu> ppdu,
@@ -250,9 +299,11 @@
     // LogComponentEnable ("WifiPhyCcaTest", LOG_LEVEL_ALL);
 
     m_device = CreateObject<WifiNetDevice>();
-    m_device->SetStandard(WIFI_STANDARD_80211ax);
+    m_device->SetStandard(WIFI_STANDARD_80211be);
     m_vhtConfiguration = CreateObject<VhtConfiguration>();
     m_device->SetVhtConfiguration(m_vhtConfiguration);
+    m_ehtConfiguration = CreateObject<EhtConfiguration>();
+    m_device->SetEhtConfiguration(m_ehtConfiguration);
 
     m_phy = CreateObject<SpectrumWifiPhy>();
     m_phy->SetDevice(m_device);
@@ -262,12 +313,12 @@
 
     auto channelNum = WifiPhyOperatingChannel::FindFirst(0,
                                                          MHz_u{0},
-                                                         MHz_u{160},
-                                                         WIFI_STANDARD_80211ax,
-                                                         WIFI_PHY_BAND_5GHZ)
+                                                         MHz_u{320},
+                                                         WIFI_STANDARD_80211be,
+                                                         WIFI_PHY_BAND_6GHZ)
                           ->number;
-    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{channelNum, 160, WIFI_PHY_BAND_5GHZ, 0});
-    m_phy->ConfigureStandard(WIFI_STANDARD_80211ax);
+    m_phy->SetOperatingChannel(WifiPhy::ChannelTuple{channelNum, 320, WIFI_PHY_BAND_6GHZ, 0});
+    m_phy->ConfigureStandard(WIFI_STANDARD_80211be);
 
     m_obssPdAlgorithm = CreateObject<ConstantObssPdAlgorithm>();
     m_device->AggregateObject(m_obssPdAlgorithm);
@@ -288,6 +339,7 @@
     m_phy->SetCcaSensitivityThreshold(m_CcaSensitivity);
     m_vhtConfiguration->SetSecondaryCcaSensitivityThresholds(m_secondaryCcaSensitivityThresholds);
     m_obssPdAlgorithm->SetObssPdLevel(m_obssPdLevel);
+    m_ehtConfiguration->m_per20CcaSensitivityThreshold = m_per20CcaSensitivity;
 
     // OFDM PHY: any signal in primary channel (20 MHz) if power above CCA-ED threshold
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_OFDM),
@@ -320,15 +372,15 @@
 
     //-----------------------------------------------------------------------------------------------------------------------------------
 
-    // HT PHY: 20 MHz HT PPDU in primary channel (20 MHz) if power in primary above CCA sensitivity
-    // threshold
+    // HT PHY: 20 MHz HT PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HT),
                        CreateDummyHtPpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_PRIMARY,
                        m_CcaSensitivity);
 
-    // HT PHY: 40 MHz HT PPDU in primary channel (20 MHz) if power in primary above CCA sensitivity
-    // threshold
+    // HT PHY: 40 MHz HT PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HT),
                        CreateDummyHtPpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_PRIMARY,
@@ -399,36 +451,41 @@
                        WIFI_CHANLIST_SECONDARY,
                        std::get<0>(m_secondaryCcaSensitivityThresholds));
 
-    // VHT PHY: 20 MHz VHT PPDU in secondary40 channel (40 MHz) if power above the CCA sensitivity
-    // threshold corresponding to a 20 MHz PPDU that does not occupy the primary 20 MHz
+    // VHT PHY: 20 MHz VHT PPDU in secondary40 channel (40 MHz) if power above the CCA
+    // sensitivity threshold corresponding to a 20 MHz PPDU that does not occupy the primary 20
+    // MHz
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_VHT),
                        CreateDummyVhtPpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY40,
                        std::get<0>(m_secondaryCcaSensitivityThresholds));
 
-    // VHT PHY: 40 MHz VHT PPDU in secondary40 channel (40 MHz) if power above the CCA sensitivity
-    // threshold corresponding to a 40 MHz PPDU that does not occupy the primary 20 MHz
+    // VHT PHY: 40 MHz VHT PPDU in secondary40 channel (40 MHz) if power above the CCA
+    // sensitivity threshold corresponding to a 40 MHz PPDU that does not occupy the primary 20
+    // MHz
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_VHT),
                        CreateDummyVhtPpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY40,
                        std::get<1>(m_secondaryCcaSensitivityThresholds));
 
-    // VHT PHY: 20 MHz VHT PPDU in secondary80 channel (80 MHz) if power above the CCA sensitivity
-    // threshold corresponding to a 20 MHz PPDU that does not occupy the primary 20 MHz
+    // VHT PHY: 20 MHz VHT PPDU in secondary80 channel (80 MHz) if power above the CCA
+    // sensitivity threshold corresponding to a 20 MHz PPDU that does not occupy the primary 20
+    // MHz
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_VHT),
                        CreateDummyVhtPpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY80,
                        std::get<0>(m_secondaryCcaSensitivityThresholds));
 
-    // VHT PHY: 40 MHz VHT PPDU in secondary80 channel (80 MHz) if power above the CCA sensitivity
-    // threshold corresponding to a 40 MHz PPDU that does not occupy the primary 20 MHz
+    // VHT PHY: 40 MHz VHT PPDU in secondary80 channel (80 MHz) if power above the CCA
+    // sensitivity threshold corresponding to a 40 MHz PPDU that does not occupy the primary 20
+    // MHz
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_VHT),
                        CreateDummyVhtPpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY80,
                        std::get<1>(m_secondaryCcaSensitivityThresholds));
 
-    // VHT PHY: 80 MHz VHT PPDU in secondary80 channel (80 MHz) if power above the CCA sensitivity
-    // threshold corresponding to a 80 MHz PPDU that does not occupy the primary 20 MHz
+    // VHT PHY: 80 MHz VHT PPDU in secondary80 channel (80 MHz) if power above the CCA
+    // sensitivity threshold corresponding to a 80 MHz PPDU that does not occupy the primary 20
+    // MHz
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_VHT),
                        CreateDummyVhtPpdu(MHz_u{80}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY80,
@@ -462,29 +519,29 @@
 
     //-----------------------------------------------------------------------------------------------------------------------------------
 
-    // HE PHY: 20 MHz HE PPDU in primary channel (20 MHz) if power in primary above CCA sensitivity
-    // threshold
+    // HE PHY: 20 MHz HE PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
                        CreateDummyHePpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_PRIMARY,
                        m_CcaSensitivity);
 
-    // HE PHY: 40 MHz HE PPDU in primary channel (20 MHz) if power in primary above CCA sensitivity
-    // threshold
+    // HE PHY: 40 MHz HE PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
                        CreateDummyHePpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_PRIMARY,
                        m_CcaSensitivity);
 
-    // HE PHY: 80 MHz HE PPDU in primary channel (20 MHz) if power in primary above CCA sensitivity
-    // threshold
+    // HE PHY: 80 MHz HE PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
                        CreateDummyHePpdu(MHz_u{80}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_PRIMARY,
                        m_CcaSensitivity);
 
-    // HE PHY: 160 MHz HE PPDU in primary channel (20 MHz) if power in primary above CCA sensitivity
-    // threshold
+    // HE PHY: 160 MHz HE PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
                        CreateDummyHePpdu(MHz_u{160}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_PRIMARY,
@@ -492,56 +549,177 @@
 
     //-----------------------------------------------------------------------------------------------------------------------------------
 
-    // HE PHY: 20 MHz HE PPDU in secondary channel (20 MHz) if power above the max between the CCA
-    // sensitivity threshold corresponding to a 20 MHz PPDU that does not occupy the primary 20 MHz
-    // and the OBSS-PD level
+    // HE PHY: 20 MHz HE PPDU in secondary channel (20 MHz) if power above the max between the
+    // CCA sensitivity threshold corresponding to a 20 MHz PPDU that does not occupy the primary
+    // 20 MHz and the OBSS-PD level
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
                        CreateDummyHePpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY,
                        std::max(m_obssPdLevel, std::get<0>(m_secondaryCcaSensitivityThresholds)));
 
-    // HE PHY: 20 MHz HE PPDU in secondary40 channel (40 MHz) if power above the max between the CCA
-    // sensitivity threshold corresponding to a 20 MHz PPDU that does not occupy the primary 20 MHz
-    // and the OBSS-PD level
+    // HE PHY: 20 MHz HE PPDU in secondary40 channel (40 MHz) if power above the max between the
+    // CCA sensitivity threshold corresponding to a 20 MHz PPDU that does not occupy the primary
+    // 20 MHz and the OBSS-PD level
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
                        CreateDummyHePpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY40,
                        std::max(m_obssPdLevel, std::get<0>(m_secondaryCcaSensitivityThresholds)));
 
-    // HE PHY: 40 MHz HE PPDU in secondary40 channel (40 MHz) if power above the max between the CCA
-    // sensitivity threshold corresponding to a 40 MHz PPDU that does not occupy the primary 20 MHz
-    // and the OBSS-PD level plus 3 dB
+    // HE PHY: 40 MHz HE PPDU in secondary40 channel (40 MHz) if power above the max between the
+    // CCA sensitivity threshold corresponding to a 40 MHz PPDU that does not occupy the primary
+    // 20 MHz and the OBSS-PD level plus 3 dB
     VerifyCcaThreshold(
         m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
         CreateDummyHePpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
         WIFI_CHANLIST_SECONDARY40,
         std::max(m_obssPdLevel + dB_u{3.0}, std::get<1>(m_secondaryCcaSensitivityThresholds)));
 
-    // HE PHY: 20 MHz HE PPDU in secondary80 channel (80 MHz) if power above the max between the CCA
-    // sensitivity threshold corresponding to a 20 MHz PPDU that does not occupy the primary 20 MHz
-    // and the OBSS-PD level
+    // HE PHY: 20 MHz HE PPDU in secondary80 channel (80 MHz) if power above the max between the
+    // CCA sensitivity threshold corresponding to a 20 MHz PPDU that does not occupy the primary
+    // 20 MHz and the OBSS-PD level
     VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
                        CreateDummyHePpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
                        WIFI_CHANLIST_SECONDARY80,
                        std::max(m_obssPdLevel, std::get<0>(m_secondaryCcaSensitivityThresholds)));
 
-    // HE PHY: 40 MHz HE PPDU in secondary80 channel (80 MHz) if power above the max between the CCA
-    // sensitivity threshold corresponding to a 40 MHz PPDU that does not occupy the primary 20 MHz
-    // and the OBSS-PD level plus 3 dB
+    // HE PHY: 40 MHz HE PPDU in secondary80 channel (80 MHz) if power above the max between the
+    // CCA sensitivity threshold corresponding to a 40 MHz PPDU that does not occupy the primary
+    // 20 MHz and the OBSS-PD level plus 3 dB
     VerifyCcaThreshold(
         m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
         CreateDummyHePpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
         WIFI_CHANLIST_SECONDARY80,
         std::max(m_obssPdLevel + dB_u{3.0}, std::get<1>(m_secondaryCcaSensitivityThresholds)));
 
-    // HE PHY: 80 MHz HE PPDU in secondary80 channel (80 MHz) if power above the max between the CCA
-    // sensitivity threshold corresponding to a 80 MHz PPDU that does not occupy the primary 20 MHz
-    // and the OBSS-PD level plus 6 dB
+    // HE PHY: 80 MHz HE PPDU in secondary80 channel (80 MHz) if power above the max between the
+    // CCA sensitivity threshold corresponding to a 80 MHz PPDU that does not occupy the primary
+    // 20 MHz and the OBSS-PD level plus 6 dB
     VerifyCcaThreshold(
         m_phy->GetPhyEntity(WIFI_MOD_CLASS_HE),
         CreateDummyHePpdu(MHz_u{80}, m_phy->GetOperatingChannel()),
         WIFI_CHANLIST_SECONDARY80,
         std::max(m_obssPdLevel + dB_u{6.0}, std::get<2>(m_secondaryCcaSensitivityThresholds)));
+
+    //-----------------------------------------------------------------------------------------------------------------------------------
+
+    // EHT PHY: any signal in primary channel (20 MHz) if power above CCA-ED threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       nullptr,
+                       WIFI_CHANLIST_PRIMARY,
+                       m_CcaEdThreshold);
+
+    // EHT PHY: any signal in secondary channel (20 MHz) if power above CCA-ED threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       nullptr,
+                       WIFI_CHANLIST_SECONDARY,
+                       m_CcaEdThreshold);
+
+    // EHT PHY: any signal in secondary40 channel (40 MHz) if power in any 20 MHz subchannel
+    // above CCA-ED threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       nullptr,
+                       WIFI_CHANLIST_SECONDARY40,
+                       m_CcaEdThreshold);
+
+    // EHT PHY: any signal in secondary80 channel (80 MHz) if power in any 20 MHz subchannel
+    // above CCA-ED threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       nullptr,
+                       WIFI_CHANLIST_SECONDARY80,
+                       m_CcaEdThreshold);
+
+    // EHT PHY: any signal in secondary160 channel (160 MHz) if power in any 20 MHz subchannel
+    // above CCA-ED threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       nullptr,
+                       WIFI_CHANLIST_SECONDARY160,
+                       m_CcaEdThreshold);
+
+    //-----------------------------------------------------------------------------------------------------------------------------------
+    // EHT PHY: 20 MHz EHT PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_PRIMARY,
+                       m_CcaSensitivity);
+    // EHT PHY: 40 MHz EHT PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_PRIMARY,
+                       m_CcaSensitivity);
+
+    // EHT PHY: 80 MHz EHT PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{80}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_PRIMARY,
+                       m_CcaSensitivity);
+
+    // EHT PHY: 160 MHz EHT PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{160}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_PRIMARY,
+                       m_CcaSensitivity);
+
+    // EHT PHY: 320 MHz EHT PPDU in primary channel (20 MHz) if power in primary above CCA
+    // sensitivity threshold
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{320}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_PRIMARY,
+                       m_CcaSensitivity);
+
+    //-----------------------------------------------------------------------------------------------------------------------------------
+
+    // EHT PHY: 20 MHz EHT PPDU in secondary channel (20 MHz) if power above the max between the
+    // CCA sensitivity threshold for Per 20MHz check and the OBSS-PD level
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_SECONDARY,
+                       std::max(m_obssPdLevel, m_per20CcaSensitivity));
+
+    // EHT PHY: 20 MHz EHT PPDU in secondary40 channel (40 MHz) if power above the max between
+    // the CCA sensitivity threshold for Per 20MHz check and the OBSS-PD level
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{20}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_SECONDARY40,
+                       std::max(m_obssPdLevel, m_per20CcaSensitivity));
+
+    // EHT PHY: 40 MHz EHT PPDU in secondary40 channel (40 MHz) if power above the max between
+    // the CCA sensitivity threshold for Per 20MHz check and the OBSS-PD level
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_SECONDARY40,
+                       std::max(m_obssPdLevel, m_per20CcaSensitivity));
+
+    // EHT PHY: 20 MHz EHT PPDU in secondary80 channel (80 MHz) if power above the max between
+    // the CCA sensitivity threshold for Per 20MHz check and the OBSS-PD level
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{80}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_SECONDARY80,
+                       std::max(m_obssPdLevel, m_per20CcaSensitivity));
+
+    // EHT PHY: 40 MHz EHT PPDU in secondary80 channel (80 MHz) if power above the max between
+    // the CCA sensitivity threshold for Per 20MHz check and the OBSS-PD level
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{40}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_SECONDARY80,
+                       std::max(m_obssPdLevel, m_per20CcaSensitivity));
+
+    // EHT PHY: 80 MHz EHT PPDU in secondary80 channel (80 MHz) if power above the max between
+    // the CCA sensitivity threshold for Per 20MHz check and the OBSS-PD level
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(MHz_u{80}, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_SECONDARY80,
+                       std::max(m_obssPdLevel, m_per20CcaSensitivity));
+
+    // EHT PHY: 160 MHz EHT PPDU in secondary160 channel (160 MHz) if power above the max
+    // between the CCA sensitivity threshold for Per 20MHz check and the OBSS-PD level
+    VerifyCcaThreshold(m_phy->GetPhyEntity(WIFI_MOD_CLASS_EHT),
+                       CreateDummyEhtPpdu(160, m_phy->GetOperatingChannel()),
+                       WIFI_CHANLIST_SECONDARY160,
+                       std::max(m_obssPdLevel, m_per20CcaSensitivity));
 }
 
 void
@@ -552,6 +730,7 @@
     m_CcaSensitivity = dBm_u{-82};
     m_secondaryCcaSensitivityThresholds = std::make_tuple(dBm_u{-72}, dBm_u{-72}, dBm_u{-69});
     m_obssPdLevel = dBm_u{-82};
+    m_per20CcaSensitivity = dBm_u{-72.0};
     RunOne();
 
     // default attributes with OBSS-PD level set to -80 dBm
@@ -559,6 +738,7 @@
     m_CcaSensitivity = dBm_u{-82};
     m_secondaryCcaSensitivityThresholds = std::make_tuple(dBm_u{-72}, dBm_u{-72}, dBm_u{-69});
     m_obssPdLevel = dBm_u{-80};
+    m_per20CcaSensitivity = dBm_u{-72.0};
     RunOne();
 
     // default attributes with OBSS-PD level set to -70 dBm
@@ -566,6 +746,7 @@
     m_CcaSensitivity = dBm_u{-82};
     m_secondaryCcaSensitivityThresholds = std::make_tuple(dBm_u{-72}, dBm_u{-72}, dBm_u{-69});
     m_obssPdLevel = dBm_u{-70};
+    m_per20CcaSensitivity = dBm_u{-72.0};
     RunOne();
 
     // CCA-ED set to -65 dBm
@@ -573,6 +754,7 @@
     m_CcaSensitivity = dBm_u{-82};
     m_secondaryCcaSensitivityThresholds = std::make_tuple(dBm_u{-72}, dBm_u{-72}, dBm_u{-69});
     m_obssPdLevel = dBm_u{-82};
+    m_per20CcaSensitivity = dBm_u{-72.0};
     RunOne();
 
     // CCA sensitivity for signals in primary set to -75 dBm
@@ -580,6 +762,7 @@
     m_CcaSensitivity = dBm_u{-75};
     m_secondaryCcaSensitivityThresholds = std::make_tuple(dBm_u{-72}, dBm_u{-72}, dBm_u{-69});
     m_obssPdLevel = dBm_u{-82};
+    m_per20CcaSensitivity = dBm_u{-72.0};
     RunOne();
 
     // custom CCA sensitivities for signals not in primary
@@ -587,6 +770,7 @@
     m_CcaSensitivity = dBm_u{-72};
     m_secondaryCcaSensitivityThresholds = std::make_tuple(dBm_u{-70}, dBm_u{-70}, dBm_u{-70});
     m_obssPdLevel = dBm_u{-82};
+    m_per20CcaSensitivity = -75.0;
     RunOne();
 
     // custom CCA sensitivities for signals not in primary with OBSS-PD level set to -80 dBm
@@ -594,6 +778,7 @@
     m_CcaSensitivity = dBm_u{-72};
     m_secondaryCcaSensitivityThresholds = std::make_tuple(dBm_u{-70}, dBm_u{-70}, dBm_u{-70});
     m_obssPdLevel = dBm_u{-80};
+    m_per20CcaSensitivity = -69.0;
     RunOne();
 
     // custom CCA sensitivities for signals not in primary with OBSS-PD level set to -70 dBm
@@ -601,6 +786,7 @@
     m_CcaSensitivity = dBm_u{-72};
     m_secondaryCcaSensitivityThresholds = std::make_tuple(dBm_u{-70}, dBm_u{-70}, dBm_u{-70});
     m_obssPdLevel = dBm_u{-70};
+    m_per20CcaSensitivity = -66.0;
     RunOne();
 
     Simulator::Destroy();
@@ -627,9 +813,9 @@
         NS_LOG_FUNCTION(this);
     }
 
-    void NotifyRxEndError() override
+    void NotifyRxEndError(const WifiTxVector& txVector) override
     {
-        NS_LOG_FUNCTION(this);
+        NS_LOG_FUNCTION(this << txVector);
     }
 
     void NotifyTxStart(Time duration, dBm_u txPower) override
@@ -696,7 +882,12 @@
 class WifiPhyCcaIndicationTest : public TestCase
 {
   public:
-    WifiPhyCcaIndicationTest();
+    /**
+     * Constructor
+     *
+     * @param standard the standard to use for the test
+     */
+    WifiPhyCcaIndicationTest(WifiStandard standard);
 
   private:
     void DoSetup() override;
@@ -704,12 +895,12 @@
     void DoTeardown() override;
 
     /**
-     * Send an HE SU PPDU
+     * Send a HE or EHT SU PPDU
      * @param txPower the transmit power
      * @param frequency the center frequency the transmitter is operating on
      * @param bandwidth the bandwidth to use for the transmission
      */
-    void SendHeSuPpdu(dBm_u txPower, MHz_u frequency, MHz_u bandwidth);
+    void SendSuPpdu(dBm_u txPower, MHz_u frequency, MHz_u bandwidth);
 
     /**
      * Start to generate a signal
@@ -819,29 +1010,42 @@
     void Reset();
 
     /**
+     * Reset the expected Per 20 MHz CCA durations
+     */
+    void ResetExpectedPer20MhzCcaBusyDurations();
+
+    /**
      * Run one function
      */
     void RunOne();
 
+    WifiStandard m_standard; ///< The standard to use for the test
+
     Ptr<SpectrumWifiPhy> m_rxPhy; ///< PHY object of the receiver
     Ptr<SpectrumWifiPhy> m_txPhy; ///< PHY object of the transmitter
 
     std::vector<Ptr<WaveformGenerator>> m_signalGenerators; ///< Generators of non-wifi signals
-    std::size_t
-        m_numSignalGenerators; ///< The number of non-wifi signals generators needed for the test
+    std::size_t m_numSignalGenerators; ///< The number of non-wifi signals generators needed for
+                                       ///< the test
 
     std::shared_ptr<CcaTestPhyListener>
         m_rxPhyStateListener; ///< Listener for PHY state transitions
 
     MHz_u m_frequency;    ///< Operating frequency
     MHz_u m_channelWidth; ///< Operating channel width
+
+    std::vector<std::vector<Time>>
+        m_expectedPer20MhzCcaBusyDurations{}; ///< expected Per 20Mhz CCA durations per check
 };
 
-WifiPhyCcaIndicationTest::WifiPhyCcaIndicationTest()
-    : TestCase("Wi-Fi PHY CCA indication test"),
-      m_numSignalGenerators(2),
-      m_frequency(P20_CENTER_FREQUENCY),
-      m_channelWidth(MHz_u{20})
+WifiPhyCcaIndicationTest::WifiPhyCcaIndicationTest(WifiStandard standard)
+    : TestCase("Wi-Fi PHY CCA indication test for " + ((standard == WIFI_STANDARD_80211ax)
+                                                           ? std::string("802.11ax")
+                                                           : std::string("802.11be"))),
+      m_standard{standard},
+      m_numSignalGenerators{2},
+      m_frequency{P20_CENTER_FREQUENCY},
+      m_channelWidth{MHz_u{20}}
 {
 }
 
